import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

import ag.debug.Debugger;
import ag.genomeenvoder.compressor.RunLengthEncoding;


public class DumpRLEGenomeToSql {
	public static void main(String args[]){
		Connection conn = null;
		try {
			
			Class.forName ("com.mysql.jdbc.Driver").newInstance();
			conn = DriverManager.getConnection ("jdbc:mysql://localhost:3306/genomedb","genomedb", "genomedb");
			PreparedStatement stat = conn.prepareStatement(
			        "SELECT identification,sequence_data FROM genomeEntity",
			        ResultSet.TYPE_FORWARD_ONLY,
			        ResultSet.CONCUR_READ_ONLY);
			stat.setFetchSize(Integer.MIN_VALUE);
			ResultSet res = stat.executeQuery();
			Connection conn2 = DriverManager.getConnection ("jdbc:mysql://localhost:3306/genomedb","genomedb", "genomedb");
			
            RunLengthEncoding RLE = new RunLengthEncoding();
            int differenceBefore = 0;
            int differenceAfter = 0;
            int difference = 0;
            int counter = 0;
			while(res.next()){
				String sequence = res.getString("sequence_data");
				String encoded = RLE.encode(sequence);
				String query = "INSERT INTO rle_genomeEntity VALUES(NULL,'"+res.getString("identification")+"','"+encoded+"');";
				Statement statIns = conn2.createStatement();
                statIns.execute(query);
                
				counter ++;
				if(counter % 10 == 0){
					String percentage = (100*((double)counter/(double)50503))+"";
					percentage = percentage.substring(0,6);
                	Debugger.Debug(counter+" items processed, "+percentage+ "% completed");
                }
			}
			res.close();
			conn.close();
			conn2.close();
			difference = Math.round(difference / counter);
			differenceBefore = Math.round(differenceBefore/counter);
			differenceAfter = Math.round(differenceAfter/counter);
			Debugger.Debug("Average length before encoding: "+differenceBefore);
			Debugger.Debug("Average length after encoding: "+differenceAfter);
			Debugger.Debug("Average of size reduction: "+difference);
		} catch (Exception e) {
			e.printStackTrace();
		}finally{
			try {
				conn.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	    

	}
	
}
