import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import ag.debug.Debugger;
import ag.genomeenvoder.compressor.RunLengthEncoding;


public class TestRunLengthEncoding {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Connection conn = null;
		try {
			
			Class.forName ("com.mysql.jdbc.Driver").newInstance();
			conn = DriverManager.getConnection ("jdbc:mysql://localhost:3306/genomedb","genomedb", "genomedb");
			PreparedStatement stat = conn.prepareStatement(
			        "SELECT sequence_data FROM genomeEntity",
			        ResultSet.TYPE_FORWARD_ONLY,
			        ResultSet.CONCUR_READ_ONLY);
			stat.setFetchSize(Integer.MIN_VALUE);
			ResultSet res = stat.executeQuery();
            
            RunLengthEncoding RLE = new RunLengthEncoding();
            int differenceBefore = 0;
            int differenceAfter = 0;
            int difference = 0;
            int counter = 0;
			while(res.next()){
				String sequence = res.getString("sequence_data");
				String encoded = RLE.encode(sequence);
				difference += sequence.length() - encoded.length();
				differenceBefore += sequence.length();
				differenceAfter += encoded.length();
				counter ++;
			}
			res.close();
			difference = Math.round(difference / counter);
			differenceBefore = Math.round(differenceBefore/counter);
			differenceAfter = Math.round(differenceAfter/counter);
			Debugger.Debug("Average length before encoding: "+differenceBefore);
			Debugger.Debug("Average length after encoding: "+differenceAfter);
			Debugger.Debug("Average of size reduction: "+difference);
		} catch (Exception e) {
			e.printStackTrace();
		}finally{
			try {
				conn.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	    

	}

}
