package ag.genomeencoder.image;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;



public class GenomeImage {
	private BufferedImage image;
	private int width, height;
	private String id;
	
	public GenomeImage(String id, int width, int height){
		image = new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
		this.id = id;
		this.width = width;
		this.height = height;
	}
	public GenomeImage(int width, int height){
		image = new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
		this.width = width;
		this.height = height;
	}
	public void Process(ImageProcessingAlgorithm alg){
		image = alg.Process(image);
	}
	public void saveImage(String filepath) throws IOException{
		File outputFile = new File(filepath);
	    ImageIO.write(image, "JPEG", outputFile);
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public BufferedImage getImage() {
		return image;
	}
	public int getWidth() {
		return width;
	}
	public int getHeight() {
		return height;
	}
}
