package ag.genomeenvoder.compressor;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import ag.debug.Debugger;
 
public class RunLengthEncoding {
 
	public String encode(String source) {
		StringBuffer dest = new StringBuffer();
		for (int i = 0; i < source.length() - 1; i++) {
			if (source.charAt(i) != source.charAt(i + 1)) {
				dest.append(source.charAt(i));
			}
		}
		dest.append(source.charAt(source.length() - 1));
		return dest.toString();
	}
	public String encodeOriginal(String source) {
		StringBuffer dest = new StringBuffer();
		int counter = -1;
		for (int i = 0; i < source.length() - 1; i++) {
			if (source.charAt(i) != source.charAt(i + 1)) {
				dest.append(i - counter);
				dest.append(source.charAt(i));
				counter = i;
			}
		}
		dest.append(source.length() - counter - 1);
		dest.append(source.charAt(source.length() - 1));
		return dest.toString();
	}
 
	public String decode(String source) {
		StringBuffer dest = new StringBuffer();
		Pattern pattern = Pattern.compile("[0-9]+|[a-zA-Z]");
		Matcher matcher = pattern.matcher(source);
 
		while (matcher.find()) {
			int number = Integer.parseInt(matcher.group());
			matcher.find();
			while (number-- != 0) {
				dest.append(matcher.group());
			}
		}
		return dest.toString();
	}
 
	public static void main(String[] args) {
             RunLengthEncoding RLE = new RunLengthEncoding();
             String example = "gggactctcc aacggctccc cgaggagctc gagaggacga ttaagtcatc ctcgagggac ctcgcccgag gagcggtgga gctcgtactg gcgagttacc aggccaggac cccgacttct ccccatggac ggcgctggac gagttccctc ccgggaccga ggacggcgcg cgcgcgcagg tccgggacgc cgccgaccac atcgtccaca gcttcgaggg ttcggcccct cagctcgcgt tctccctcaa ctccgacgag gaggacgatg acggcggagt gggcgacagt ggcgacgagg ctggcgatcc gggtgcatcg gagtgagccc ccaggccccc gccaatttta aatagtttct tctttcttct tcgaaggcct tcgggcctcc tttttgtata gattcactta atctgcaatc aaaataaaga aatttctgtg tcaattttat tttgctatgt gtatgcgatg aggatgatct gtgccgtggt ccttttgtgt cttagcttga ctaagggctc gtgcccaggt cccagtcctc aaaaggcgcg ggtcggggct agtgcctggg gagatccacg tgtcgagact ggccaggccg ggagcgtggt gaccgagggt tatgggtgac ccgattgtgg gtttttgccg attccccccc ggagttcacc acgccccggg gcacggcttg gttctgggcc ccttttggcg attttagccg acccgagccc ccgagggcaa gattgagcac gagtgaccta tttcaagtca agattcttca aaagaaaata acagcacaga tacagccttt aggaaattga aaatgctttt attgaaatac agatataaga gaaataagaa tatgcatatg tggtagcccc cggccaaccc tgcacgcccg aggggggtgc ggggttggcc cgagcccgaa acctgacacc cgatccccct taggggtaga agcgacgaag gtgttcgatg ttccacgggt taggcagctc tgtgccgtcg cccgtggcta gccgaacgga gcccagccgg gggacgccga tcactcgata cggaccctcc cacattggtg agagtttgct caatccagca cgcgtttgga cgcggcgtag gacgaggtcg tcgacgcaga gtgatcgggc ccggacgtgg cgctgatggt agcgccgcag gctctgctgg tagcgcgcgg ctcggagggc cgcgcgccgc cttcgctctt ccaagtagtc gagtgtcagg ctctggcgaa cgctgatcct tgatacagcc tccgcagtac actggtggcc acgaggggac ctcagggttg agctctggat gtggagaacc tgtcgcgtgc ccaaaacgat ctctgaaaat acatgcctcg aaattgtgcc atagaataat taaaatccca tgtgaaagcc tccaaccaat taaaatgtgc caaatttaaa agtgcaaata agggcttgga cggattttgt gtatatttgc ctaaaacgcc taaaatggcg taaacacact tttgagtgga attttgcaga gcaccaaata ataacctgag aacgaaataa accaaacgtt aaaaacggtt ttataaaaag aaaaaccgct aaaaagtctt ctttccaccc ccttcccttc ttgggccggc tcggcccagt cccctccctc tctctcctct cccccgcggc ccatcggccc ttccccgcgc";
             example = example + example + example + example;
             String result = RLE.encode(example);
             //result = result.replaceAll("[0-9]*", "");
             Debugger.Debug("Length before: "+example.length());
             Debugger.Debug("Length after: "+result.length());
             
             //System.out.println(RLE.decode("1W1B1W1B1W1B1W1B1W1B1W1B1W1B"));
	}
}