package ag.genomelire;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.LinkedList;

import org.apache.lucene.analysis.SimpleAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexWriter;

import ag.debug.Debugger;

import net.semanticmetadata.lire.DocumentBuilder;
import net.semanticmetadata.lire.DocumentBuilderFactory;

public class Indexer {
	private String fileFolder = "";
	private String output;
	private double percentage = 0;
	
	public Indexer(String folder,String output){
		this.fileFolder = folder;
		this.output = output;
	}
	private String[] getFilesInFolder(String folder,String extension){
		File myDir = new File(folder);
		LinkedList<String> filenames = new LinkedList<String>();
		if( myDir.exists() && myDir.isDirectory()){
			File[] files  = myDir.listFiles();
			for(int i=0; i < files.length; i++){
				File tmp = files[i];
				String filename = tmp.getName();
				if(filename.toLowerCase().contains("."+extension.toLowerCase())){
					filenames.add(filename);
				}
			}
		}
		String[] retval = new String[filenames.size()];
		for(int i = 0; i < retval.length; i++){
			retval[i] = filenames.get(i);
		}
		return retval;
	}
	@SuppressWarnings("deprecation")
	public void buildIndex() throws IOException {
		
		
	    //private String[] testFiles = new String[]{"img01.JPG", "img02.JPG", 
	    //		"img03.JPG", "img04.JPG", "img05.JPG"};
	        String testFilesPath = fileFolder;
	        String[] fileNames = getFilesInFolder(fileFolder,"jpg");
	        String indexPath = output;
	        //String testExtensive = "../Caliph/testdaten";
	        
            // Create an appropriate DocumentBuilder
            DocumentBuilder builder = DocumentBuilderFactory.getExtensiveDocumentBuilder();
            
            IndexWriter iw = new IndexWriter(indexPath, new SimpleAnalyzer(), true);
            double tickPercentage = 100/fileNames.length;
            int counter = 0;
            for (String identifier : fileNames) {
                // Build the Lucene Documents
                Document doc = builder.createDocument(new FileInputStream(testFilesPath+identifier), identifier);
                // Add the Documents to the index
                iw.addDocument(doc);
                percentage += tickPercentage;
                Debugger.Debug("Item #"+counter+ " - " +percentage + "% Complete");
                counter ++;
            }
            iw.optimize();
            iw.close();
	        
	}
	public double getPercentage(){
		return percentage;
	}
}
