package ag.genomelire;
import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

import ag.debug.Debugger;

public class ResultFileParser {
	@SuppressWarnings("deprecation")
	public static void main(String[] args){
		String p = "/Users/alex/Documents/Skole/Masteroppgave/";
		String[] files = {"resultsscaled_1000_.txt",};
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		String erroritem = "";
		String tab = '\t'+"";
			for(int i = 0; i < files.length;i++){
				try{
					fis = new FileInputStream(p+files[i]);
				    bis = new BufferedInputStream(fis);
				    dis = new DataInputStream(bis);
					int state = 0;
					int tablespan = 6;
					int tablecounter = 0;
					String output ="";
					String tablestart = "";
					String tableend = "";
					LinkedList<String> subtables = new LinkedList<String>();
					String subtable = "";
				while (dis.available() != 0) {
					boolean other = false;
					String line = dis.readLine();
					String subs = line.substring(0,8);
					
					if(subs.equals("<changed")){
						state = 1;
						tablestart = "\\begin{table}[!ht]"+'\n'+'\t'+"\\centering"+'\n';
						String changedlevel = line.substring(8,10);
						if(changedlevel.contains(">")){
							changedlevel = line.substring(8,9);
						}
						tablestart+=tab+"\\caption{Query sequences with "+changedlevel+" changed nucleotides}"+'\n';
						other = true;
					}else if(subs.equals("</changed") || subs.equals("</change")){
						state = 0;
						tableend = "\\end{table}"+'\n';
						other = true;
						int tabls = 0;
						int counter = 0;
						String tmp = "";
						
						for(int k = 0; k < subtables.size();k++){
							if(counter == 6){
								output+= tablestart+tmp+tableend+'\n'+" \\clearpage"+'\n';
								counter = 0;
								tmp = "";
							}
							tmp += subtables.get(k);
							counter ++;
						}
						if(tmp.length() != 0){
							output+= tablestart+tmp+tableend+'\n'+"\\newpage"+'\n';
						}
						subtables = new LinkedList<String>();
					}else if(subs.equals("########")){
						if(state == 1){
							state = 2;
						}else{
							if(state == 2){
								state = 1;
								subtable+=tab+"\\end{tabular}"+'\n';
								subtable+=tab+"}"+'\n';
								subtables.add(subtable);
								subtable = "";
							}
						}
						other = true;
					}else if(subs.equals("RESULTS ") && state != 1){
						String id = line.substring(19,31);
						subtable+=tab+"\\subtable[Results for querysequence "+id+"]{"+'\n';
						subtable+=tab+tab+"\\begin{tabular}{|c|c|c|}"+'\n';
						subtable+=tab+tab+"\\hline"+'\n';
						subtable+=tab+tab+"Rank"+tab+"& Score"+tab+"& Accession Nr. "+"\\"+"\\"+" \\hline"+'\n';
						other = true;
						tablecounter ++;
					}
					if(state == 2 && !other){
						String item = line.substring(1,line.length());
						
						String[] items = item.split("[|]");
					
						subtable+=tab+tab+items[0]+'\t'+" & "+items[1]+'\t'+" & "+items[2].substring(0,12)+" \\"+"\\"+" \\hline"+'\n';	
					}
					
						
				}
				
				fis.close();
				bis.close();
				dis.close();
				FileWriter fstream;
				BufferedWriter out = null;
				fstream = new FileWriter(p+files[i]+".tex");
				out = new BufferedWriter(fstream);
				out.write(output);
				out.close();
				}catch(Exception e){
					e.printStackTrace();
					System.out.println(erroritem);
				}
			
		
			}
	}
	public static LinkedList<String>[] getFourierResults(){
		String p = "/Users/alex/Documents/Skole/Masteroppgave/";
		String[] files = {"results_fourier_changed.txt",};
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		LinkedList[]  lists= new LinkedList[10];
		DataInputStream dis = null;
		String erroritem = "";
		int listcounter = -1;
		String tab = '\t'+"";
			for(int i = 0; i < files.length;i++){
				try{
					fis = new FileInputStream(p+files[i]);
				    bis = new BufferedInputStream(fis);
				    dis = new DataInputStream(bis);
					int state = 0;
					int tablespan = 6;
					int tablecounter = 0;
					String output ="";
					String tablestart = "";
					String tableend = "";
					String lol = "";
					LinkedList<String> subtables = new LinkedList<String>();
					String subtable = "";
				while (dis.available() != 0) {
					boolean other = false;
					String line = dis.readLine();
					String subs = line.substring(0,8);
					if(subs.equals("<changed")){
						listcounter ++;
						lists[listcounter] = new LinkedList<String>();
						state = 1;
						tablestart = "\\begin{table}[!ht]"+'\n'+'\t'+"\\centering"+'\n';
						String changedlevel = line.substring(8,10);
						if(changedlevel.contains(">")){
							changedlevel = line.substring(8,9);
						}
						tablestart+=tab+"\\caption{Query sequences with "+changedlevel+" changed nucleotides}"+'\n';
						other = true;
					}else if(subs.equals("</changed") || subs.equals("</change")){
						state = 0;
						tableend = "\\end{table}"+'\n';
						other = true;
						int tabls = 0;
						int counter = 0;
						String tmp = "";
						
						for(int k = 0; k < subtables.size();k++){
							if(counter == 6){
								output+= tablestart+tmp+tableend+'\n'+" \\clearpage"+'\n';
								counter = 0;
								tmp = "";
							}
							tmp += subtables.get(k);
							counter ++;
						}
						if(tmp.length() != 0){
							output+= tablestart+tmp+tableend+'\n'+"\\newpage"+'\n';
						}
						subtables = new LinkedList<String>();
					}else if(subs.equals("########")){
						if(state == 1){
							state = 2;
						}else{
							if(state == 2){
								state = 1;
								subtable+=tab+"\\end{tabular}"+'\n';
								subtable+=tab+"}"+'\n';
								subtables.add(subtable);
								subtable = "";
								lists[listcounter].add(lol);
								lol = "";
								
							}
						}
						other = true;
					}else if(subs.equals("RESULTS ") && state != 1){
						String id = line.substring(19,31);
						subtable+=tab+"\\subtable[Results for querysequence "+id+"]{"+'\n';
						subtable+=tab+tab+"\\begin{tabular}{|c|c|c|}"+'\n';
						subtable+=tab+tab+"\\hline"+'\n';
						subtable+=tab+tab+"Rank"+tab+"& Score"+tab+"& Accession Nr. "+"\\"+"\\"+" \\hline"+'\n';
						other = true;

						
						tablecounter ++;
					}
					if(state == 2 && !other){
						String item = line.substring(1,line.length());
						
						String[] items = item.split("[|]");
						lol += items[2].substring(0,12)+"|";
						subtable+=tab+tab+items[0]+'\t'+" & "+items[1]+'\t'+" & "+items[2].substring(0,12)+" \\"+"\\"+" \\hline"+'\n';	
					}
					
						
				}
				
				fis.close();
				bis.close();
				dis.close();
				//FileWriter fstream;
				//BufferedWriter out = null;
				//fstream = new FileWriter(p+files[i]+".tex");
				//out = new BufferedWriter(fstream);
				//out.write(output);
				//out.close();
				}catch(Exception e){
					e.printStackTrace();
					System.out.println(erroritem);
				}
			
		
			}
			return lists;
	}
}
