package ag.genomelire;

import java.awt.image.BufferedImage;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Random;

import javax.swing.DefaultComboBoxModel;
import javax.swing.ListModel;

import ag.debug.Debugger;
import ag.liregui.SearchController;


import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public class SearchBenchmark {

	/**
	 * @param args
	 */
	public static void main(String[] args)  {
		//String indexlocation = "/Users/alex/Desktop/GenomeImages/fourier_index/";
		
		String indexlocation = "/Users/alex/Desktop/GenomeImages/scaled_1000_index/";
		String resultfile = "/Users/alex/Documents/Skole/Masteroppgave/resultsscaled_1000_.txt";
		String dataset = "/Users/alex/Documents/Skole/Masteroppgave/dataset.xml";
		SearchController searcher = new SearchController();
		DOMParser parser = new DOMParser();
		FileWriter fstream;
		BufferedWriter out = null;
		try {
			parser.parse(dataset);
			fstream = new FileWriter(resultfile);
			out = new BufferedWriter(fstream);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		searcher.loadIndex(indexlocation);
		
		Document document = parser.getDocument();
		NodeList nodes = document.getElementsByTagName("row");
		int nodelistlength = nodes.getLength();
		int errorcounter = 0;
		String idthatfailed = "";
		Debugger.Debug(nodelistlength+"");/*
		for(int k = 0; k < 10;k++){
			try {
				out.write("<changed"+k*5+">"+'\n');
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}*/
			for(int i = 0; i < nodelistlength; i++) {
			 	Element row = (Element)nodes.item(i);
			 	NodeList children = row.getElementsByTagName("field");
			 	Node data = children.item(0);
			 	Node id = children.item(1);
			 	//Debugger.Debug("SEARCHING IN ITEM NR: "+i);
			 	try{
			 	String text = data.getTextContent();
			 	AnalyzeQueryDifferences(text,id.getTextContent());
			 	/*text = changeSomeChars(text,5*k);
			 	DefaultComboBoxModel l = (DefaultComboBoxModel)searcher.searchScale(text,1000);
				 	try{
				 		out.write("########################################"+'\n');
				 		out.write("RESULTS FOR QUERY: "+id.getTextContent()+'\n');
					 	for(int j=0;j<l.getSize();j++){
					 		String lol = (String)l.getElementAt(j);
					 		out.write(lol+'\n');
					 	}
				 		
				 	}catch(Exception e){
				 		Debugger.Debug("ERROR WRITING TO FILE");
				 		errorcounter +=1;
				 	} */
			 	}catch(Exception e){
			 		errorcounter += 1;
			 		idthatfailed = id.getTextContent();
			 	}	
			}/*
			try {
				int pdsa = 0;
				//out.write("</changed"+k*5+">"+'\n');
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}*/
		//}
		
		try{
		out.close();
		}catch(Exception e){
			
		}
		Debugger.Debug("ERRORS IN SEARCHING: "+errorcounter+" on id "+idthatfailed);
	}
	public static void AnalyzeQueryDifferences(String input,String id){
		int a,c,t,g;
		a = c = t = g = 0;
		for(int i = 0; i<input.length();i++){
			switch(input.charAt(i)){
			case 'a':
				a ++;
				break;
			case 'c':
				c++;
				break;
			case 't':
				t++;
				break;
			case 'g':
				g++;
				break;
			}
		}
		float aper = (float)((float)a/(float)input.length())*(float)100; 
		float cper = (float)((float)c/(float)input.length())*(float)100; 
		float tper = (float)((float)t/(float)input.length())*(float)100; 
		float gper = (float)((float)g/(float)input.length())*(float)100;
		float total = Math.abs(aper-(float)25);
		total += Math.abs(aper-(float)25);
		total += Math.abs(aper-(float)25);
		total += Math.abs(aper-(float)25);
		//System.out.println(id.substring(0,12)+"    "+aper+"\t,"+cper+"\t,"+tper+"\t,"+gper);
		System.out.println(id.substring(0,12)+" "+total);
	}
	public static String changeSomeChars(String input, int numberOfChars){
		boolean running = true;
		Random gen = new Random( 1958047827);
		if(numberOfChars == 0){
			return input;
		}
		int numberofchanged = 0;
		while(running){
			int random = gen.nextInt(input.length()-1);
			char c = input.charAt(random);
			if(c != ' '){
				input = input.substring(0,random)+getRandomNuc(c)+input.substring(random+1,input.length());
				numberofchanged ++;
			}
			if(numberofchanged == numberOfChars){
				running = false;
			}
		}
		return input;
	}
	public static char getRandomNuc(char n){
		char retval = 'a';
		char[] vals = new char[3];
		switch(n){
			case 'a':
				vals[0] = 'c';
				vals[1] = 't';
				vals[2] = 'g';
			break;
			case 'c':
				vals[0] = 'a';
				vals[1] = 't';
				vals[2] = 'g';
			break;
			case 't':
				vals[0] = 'a';
				vals[1] = 'c';
				vals[2] = 'g';
			break;
			case 'g':
				vals[0] = 'a';
				vals[1] = 'c';
				vals[2] = 't';
			break;
		}
		Random gen = new Random( 19580427);
		return vals[gen.nextInt(3)];
	}
}
