package ag.lirebenchmark;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Calendar;
import java.util.Date;

import ag.debug.Debugger;
import ag.lirebenchmark.preprocessingalgorithms.*;

public class Benchmark {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		PreProcessingAlgorithm[] algs = new PreProcessingAlgorithm[4];
		String[] indexes = new String[4];
		
		algs[0] = new NoneProcessingAlgorithm(); 
		algs[1] = new RLEEncodeAlgorithm();
		algs[2] = new ScaleImage300Algorithm();
		algs[3] = new ScaleImage700Algorithm();
		
		indexes[0] = "/Users/alex/Desktop/GenomeImages/index/";
		indexes[1] = "/Users/alex/Desktop/GenomeImages/rle_index/";
		indexes[2] = "/Users/alex/Desktop/GenomeImages/scaled_300_index/";
		indexes[3] = "/Users/alex/Desktop/GenomeImages/scaled_700_index/";
		
		LireGenomeIndexSearcher searcher = new LireGenomeIndexSearcher(indexes,algs);
		Debugger.Debug("Created objects");
		try{
			searcher.loadIndex();
		}catch(Exception e){
			Debugger.Debug("Could not load indexes");
			e.printStackTrace();
		}
		Debugger.Debug("Loaded indexes");
		String query = "ccacttcttg cggagaacgc aggggatgta gcggttcagc accggccccc gcggctggaa gtagcagcca ccaaccaccg acggcggcga caccgactgt acggtgaaga accaccggaa cagccgaagg gatgggcgca ccccgatgaa catctcgcac aggtgcgcga agatggccaa tgtcattacc gcgttggggg tgaggtgcgc catctggaga tcgtaaaact ccagaacatc catgaagaaa gaagaaaatg gcggaaccag ccctgccatt gcaaaaggga ggaagaagac ggaccgcccc gggtagcatg gcgccaggcg tccctcgccc agcgtgacta tctcccggcc ggtggcagat tccggcatga agcggcgcgg cagcctggcc tgcctctcgc tcacgatgcg ggaaggcggc agcacgctac catcgagcag agcggagccc cgtgccatga cgccggaaga agagatgttt gagagcaagc gcgtgtggcg agggtagggc acaggaaaca aggagttagg gcgcaagcgg tgaagacaag gagaataatg gcgagaggaa ggaagcaaat ctcttcctcg gtgtctttat acccttgcca acgctgtgcc cggctcctcg cttctcgcgc ccactatctc gctccctcgt ttctcgcgcc cacgcttcca ctaatcccat tcgcccgctt gcggcgcatg aggtggatat gcggctgtgg cagtcgagat ggaacatatc gtgcgcgcgt tgattacgct cgccgaccga agcgccatca ccatatctca aggtaaaacg aaccggctcg tcccgattcg tgtgctactc gagtaatgtg gcagtcttga agagaccgct cattattggc agccgagtta ccattgccga tgtgcgtgat ttgcgaccgt tgggtttctg cccaactgtg gagaccggtc ccacctgtca ccaggcctta ggaagtggcg tcacgcccga ccgcttcct";
		String[][] results = searcher.search(query);
		
		Calendar cal = Calendar.getInstance();
		String filename = "/Users/alex/Desktop/GenomeImages/results"+cal.get(Calendar.MONTH)+"-"+cal.get(Calendar.DAY_OF_MONTH)+"-"+cal.get(Calendar.YEAR)+"-"+cal.get(Calendar.HOUR_OF_DAY)+":"+cal.get(Calendar.MINUTE)+":"+cal.get(Calendar.SECOND)+".txt";
		try{
			BufferedWriter out = new BufferedWriter(new FileWriter(filename));
			for(int i = 0; i < results.length;i++){
				out.write("##########################################################"+'\n');
				out.write("Index: "+indexes[i]+" , Hits;"+'\n');
				out.write("##########################################################"+'\n');
				for(int j = 0; j < results[i].length; j++){
					out.write(results[i][j]+'\n');
				}
				out.write("##########################################################"+'\n');
			}
		out.close();
		}catch(Exception e){
			e.printStackTrace();
		}
		Debugger.Debug("Wrote results to "+filename);
		
	}

}
