package ag.lirebenchmark;

import java.io.IOException;

public class LireGenomeIndexSearcher {
	private LireGenomeIndex[] indexes;
	
	public LireGenomeIndexSearcher(String[] indexpaths, PreProcessingAlgorithm[] algs){
		indexes = new LireGenomeIndex[indexpaths.length];
		for(int i = 0; i < indexpaths.length; i++){
			indexes[i] = new LireGenomeIndex(indexpaths[i],algs[i]);
		}
	}
	public void loadIndex() throws IOException{
		for(int i = 0 ; i < indexes.length;i++){
			indexes[i].loadIndex();
		}
	}
	
	public String[][] search(String input){
		String[][] resultlist = new String[indexes.length][100];
	
		for(int i = 0; i < indexes.length;i++){
			resultlist[i] = indexes[i].search(input);
		}
		
		return resultlist;
	}
	
}
