package ag.lirebenchmark.blastsearch;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Random;

import javax.swing.DefaultComboBoxModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import ag.debug.Debugger;
import ag.liregui.SearchController;

import com.sun.org.apache.xerces.internal.parsers.DOMParser;
import com.sun.org.apache.xerces.internal.xni.parser.XMLInputSource;

public class BatchQuery {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub


		String dataset = "/Users/alex/Documents/Skole/Masteroppgave/dataset.xml";

		DOMParser parser = new DOMParser();

		try {
			parser.parse(dataset);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 

		
		Document document = parser.getDocument();
		NodeList nodes = document.getElementsByTagName("row");
		int nodelistlength = nodes.getLength();
		Debugger.Debug(nodelistlength+"");
		String shellscript = "";
		for(int i = 0; i < nodelistlength;i++){
			String input = "";
		 	Element row = (Element)nodes.item(i);
		 	NodeList children = row.getElementsByTagName("field");
		 	Node data = children.item(0);
		 	Node id = children.item(1);
		 	Debugger.Debug("SEARCHING IN ITEM NR: "+i);
		 	String accessionnumber = id.getTextContent().substring(0,12);
		 	Debugger.Debug("Performing query");
		 	String sdata = data.getTextContent();
			FileWriter fw;
			try {
				fw = new FileWriter("/Users/alex/Desktop/blastqueries/"+i+".txt");		
				fw.write(sdata);
				fw.close();
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			shellscript += "blast2 -i "+i+".txt -d ../sequences.fasta -p blastn | grep \"gi\\|[*]\\|gb\" | grep \"\\.\\.\\.\" | grep -o \"[a-zA-Z]*[0-9]*\\.[0-9] > "+i+"_results.txt"+'\n';
		}
		FileWriter fw;
		try {
			fw = new FileWriter("/Users/alex/Desktop/blastqueries/run_queries.sh");		
			fw.write(shellscript);
			fw.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		/*
	for(int j = 0; j < 10;j++){
		BlastSearcher s = new BlastSearcher("changed"+(j*5));
		for(int i = 0; i < nodelistlength; i++) {
		 	Element row = (Element)nodes.item(i);
		 	NodeList children = row.getElementsByTagName("field");
		 	Node data = children.item(0);
		 	Node id = children.item(1);
		 	Debugger.Debug("SEARCHING IN ITEM NR: "+i);
		 	String accessionnumber = id.getTextContent().substring(0,12);
		 	Debugger.Debug("Performing query");
		 	String sdata = data.getTextContent();
		 	if(sdata.length() > 4000){
		 		sdata = sdata.substring(0,4000);
		 	}
		 	sdata = changeSomeChars(sdata,j*5);
		 	s.performQuery(sdata,accessionnumber);
		 	Debugger.Debug("Query done");
		}
		
		ParseResultsToFile(s.name,s.output,s.numbers);
	}*/
	
	}
	public static void ParseResultsToFile(String tagname, LinkedList<String> hits,LinkedList<String> ids){
		DOMParser parser = new DOMParser();
		int splitontable = 6;
		int tablecounter = 0;
		String output = "";
		String tab = '\t'+"";
		for(int i = 0; i < hits.size();i++){
			String xml = hits.get(i);
			Document doc = null;
		     try {
		    	DocumentBuilderFactory f = DocumentBuilderFactory.newInstance();
		    	f.setValidating(false);
		    	
				DocumentBuilder builder = f.newDocumentBuilder();
				
				org.xml.sax.InputSource inStream = new org.xml.sax.InputSource();
			    inStream.setCharacterStream(new java.io.StringReader(xml));   
			    
				doc =  builder.parse(inStream);
		     } catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		     
			if(tablecounter == 0){
				output += "\\begin{table}"+'\n'+"\\centering"+'\n';
			}
			NodeList nodes = doc.getElementsByTagName("Hit");
			output += tab+tab+"\\subtable[Results for querysequence "+ids.get(i)+"]{"+'\n';
			output += tab+tab+"\\begin{tabular}[|c|c|c|"+'\n'+tab+tab+tab+"\\hline"+'\n';
			output += tab+tab+tab+"Rank &"+tab+"Score &"+tab+"& Accession Nr. \\"+"\\"+"\\hline"+'\n';
			for(int j = 0; j < nodes.getLength();j++){
				Node n = nodes.item(j);
				
				String hitno = n.getChildNodes().item(1).getTextContent();
				String hitlen = n.getChildNodes().item(9).getTextContent();
				String hita = n.getChildNodes().item(7).getTextContent();
				output += tab+tab+tab+hitno+" &"+tab+hitlen+"& "+hita+" \\ "+"\\"+"\\hline"+'\n';	
			}
			tablecounter++;
			if(tablecounter == splitontable){
				tablecounter = 0;
				output += "\\caption{Results from queries:"+tagname+"}";
				output += "\\end{table}";
			}
			output+="}"+'\n';
		}
		try{
			FileWriter fw = new FileWriter("/Users/alex/Desktop/BlastResults/"+tagname+".tex");
		    fw.write(output);
		    fw.close();
		    output = "";
		}catch(Exception e){
			
		}
	    
		
		
		System.out.println(output);
	}
	public static void writeToTempFile(String xml){
		try{
			FileWriter fw = new FileWriter("/tmp/123321123321.xml");
		    fw.write(xml);
		    fw.close();
		}catch(Exception e){
			
		}
	}
	public static String changeSomeChars(String input, int numberOfChars){
		boolean running = true;
		Random gen = new Random( 1958047827);
		if(numberOfChars == 0){
			return input;
		}
		int numberofchanged = 0;
		while(running){
			int random = gen.nextInt(input.length()-1);
			char c = input.charAt(random);
			if(c != ' '){
				input = input.substring(0,random)+getRandomNuc(c)+input.substring(random+1,input.length());
				numberofchanged ++;
			}
			if(numberofchanged == numberOfChars){
				running = false;
			}
		}
		return input;
	}
	public static char getRandomNuc(char n){
		char retval = 'a';
		char[] vals = new char[3];
		switch(n){
			case 'a':
				vals[0] = 'c';
				vals[1] = 't';
				vals[2] = 'g';
			break;
			case 'c':
				vals[0] = 'a';
				vals[1] = 't';
				vals[2] = 'g';
			break;
			case 't':
				vals[0] = 'a';
				vals[1] = 'c';
				vals[2] = 'g';
			break;
			case 'g':
				vals[0] = 'a';
				vals[1] = 'c';
				vals[2] = 't';
			break;
		}
		Random gen = new Random( 19580427);
		return vals[gen.nextInt(3)];
	}
	

}
