package ag.lirebenchmark.blastsearch;
import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Reader;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.CharBuffer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.concordia.cs.common.ncbi.qblast.GetCommand;

import ag.debug.Debugger;

import sun.net.www.URLConnection;

public class BlastGetter extends GetCommand{
	private static final int DEFAULT_BUFFER_SIZE = 10000;
	private String id;
	private BlastSearcher owner;
	public BlastGetter(BlastSearcher o){
		this.owner = o;
	}
	@Override
	public void parseResults(Reader in) throws Exception {
		CharBuffer buf = CharBuffer.allocate(DEFAULT_BUFFER_SIZE);
		int n = 20;
		String output = "";
		Boolean running = true;
		while(running){
			int read = in.read();
			if(read < 1){
				running = false;
			}else{
				output += (char)read;
			}
		}
		Pattern p = Pattern.compile("<strong>Formatting Results - [a-zA-Z0-9]*</strong>");
		Matcher m = p.matcher(output);
		
		String out = "";
		 while (m.find()) {
			 out = m.group();	 
		 }
		 out = out.substring(29);
		 out = out.substring(0,out.length()-9);
		 Debugger.Debug("Trying to fetch results");
		 getResponseAndWriteOuputToFile(out);
		 //System.out.println(getResponse(out));
	}
	public String getResponse(String id){
		String result = "";
		String uri = "http://blast.ncbi.nlm.nih.gov/Blast.cgi?RESULTS_FILE=on&RID="+id+"&FORMAT_TYPE=XML&FORMAT_OBJECT=Alignment&CMD=Get";
		try {
	        
	        // Send data
	        URL url = new URL(uri);
	        java.net.URLConnection conn = url.openConnection();
	        conn.setDoOutput(true);
	        OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
	        wr.flush();
	    
	        // Get the response
	        BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
	        String line;
	        while ((line = rd.readLine()) != null) {
	            result += line;
	        }
	        wr.close();
	        rd.close();
	    } catch (Exception e) {
	    }
		
		return result;
	}
	public void getResponseAndWriteOuputToFile(String id){
		String uri = "http://blast.ncbi.nlm.nih.gov/Blast.cgi?RESULTS_FILE=on&RID="+id+"&FORMAT_TYPE=XML&FORMAT_OBJECT=Alignment&CMD=Get";
		try {
			System.out.println(uri);
			
	        // Send data
	        URL url = new URL(uri);
	        java.net.URLConnection conn = url.openConnection();
	        conn.setDoOutput(true);
	        OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
	        wr.flush();
	    
	        // Get the response
	        
	        BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
	        String line;
	        String out = "";
	        while ((line = rd.readLine()) != null) {
	        	out += line+'\n';
	        }
	        this.owner.addItem(out);
	       
	        wr.close();
	        rd.close();
	    } catch (Exception e) {
	    }
		
	}
	
	
}
