package ag.lirebenchmark.blastsearch;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;



import ag.debug.Debugger;

public class BlastResultParser {

	/**
	 * @param args
	 */
	public static void main2(String[] args){
		LinkedList[] blast = null;
		try{
			blast = getFullBlast();
		}catch(Exception e){
			e.printStackTrace();
		}
		LinkedList[] fourier = GetNormalResults();

		
		float totalprecision = (float)0;
		float totalrecall = (float)0;
		for(int k = 0; k < fourier.length;k++){
			for(int i = 0; i < fourier[k].size();i++){
				LinkedList item = blast[i];
				LinkedList fres = fourier[k];
				String fourier4query = (String)fres.get(i);
				int relevant4query = 0;
				for(int j = 0; j < item.size();j++){
					if(fourier4query.contains((String) item.get(j))){
						relevant4query++;
					}
				}
				//Debugger.Debug(relevant4query+"");
				float precision = (float)relevant4query/(float)15;
				totalprecision += precision;
				if(item.size()> 0){
					float recall = (float)relevant4query/(float)item.size();
					totalrecall += recall;
				}
			}
			totalrecall = (float)totalrecall/(float)fourier[k].size();
			totalprecision = totalprecision/(float)fourier[k].size();
			System.out.println("Precision: "+totalprecision+"  Recall: "+totalrecall);
			totalrecall = 0;
			totalprecision = 0;
		}
		

		System.out.println("Precision: "+totalprecision+"  Recall: "+totalrecall);
		
	}
	public static void print(String in){
		System.out.println(in);
	}
	public static void print(float in){
		System.out.println(in);
	}
	public static LinkedList[] getFullBlast() throws Exception{
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		LinkedList[] retval= new LinkedList[50];
		DataInputStream dis = null;
		for(int i = 0; i < 50;i++){
			fis = new FileInputStream("/Users/alex/Desktop/blastresults2/"+i+"_results.txt");
		    bis = new BufferedInputStream(fis);
		    dis = new DataInputStream(bis);
		    retval[i] = new LinkedList();
		    while(dis.available() != 0){
		    	String line = dis.readLine();
		    	line = line.replace(".1", "");
		    	retval[i].add(line);
		    }
		}
		return retval;
		
	}
	public static HashMap<String, Integer> GetSequenceLengths(){
		HashMap<String, Integer> h = new HashMap<String, Integer>();
		h.put("AAAA02000024",30449);
		h.put("AAAA02000036",14406);
		h.put("AAAA02000040",980);
		h.put("AAAA02000042",14705);
		h.put("AAAA02000151",1738);
		h.put("AAAA02000024",30449);
		h.put("AAAA02000036",14406);
		h.put("AAAA02000040",980);
		h.put("AAAA02000042",14705);
		h.put("AAAA02000151",1738);
		h.put("AAAA02000682",17905);
		h.put("AAAA02000700",1673);
		h.put("AAAA02001511",8988);
		h.put("AAAA02001599",2363);
		h.put("AAAA02001967",1340);
		h.put("AAAA02002452",37151);
		h.put("AAAA02002622",2848);
		h.put("AAAA02002771",3586);
		h.put("AAAA02003169",919);
		h.put("AAAA02003401",7667);
		h.put("AAAA02005050",1640);
		h.put("AAAA02005171",25191);
		h.put("AAAA02005341",69982);
		h.put("AAAA02005562",9031);
		h.put("AAAA02005645",20680);
		h.put("AAAA02005933",5448);
		h.put("AAAA02006009",42420);
		h.put("AAAA02006169",13228);
		h.put("AAAA02006947",1949);
		h.put("AAAA02006955",8656);
		h.put("AAAA02007237",2029);
		h.put("AAAA02007903",8873);
		h.put("AAAA02008540",31655);
		h.put("AAAA02008756",1435);
		h.put("AAAA02009743",3881);
		h.put("AAAA02009968",1404);
		h.put("AAAA02010055",1776);
		h.put("AAAA02010178",5691);
		h.put("AAAA02011448",1795);
		h.put("AAAA02011922",6046);
		h.put("AAAA02012528",802);
		h.put("AAAA02012633",2650);
		h.put("AAAA02012797",3132);
		h.put("AAAA02012975",1202);
		h.put("AAAA02013123",2174);
		h.put("AAAA02013992",1317);
		h.put("AAAA02014095",19335);
		h.put("AAAA02014123",10187);
		h.put("AAAA02014504",6132);
		h.put("AAAA02014553",11425);
		h.put("AAAA02014651",18632);
		h.put("AAAA02014736",1160);
		h.put("AAAA02015743",10807);
		h.put("AAAA02015787",14311);
		h.put("AAAA02016401",7852);

		
		return h;
	}
	
	
	
	public static void main(String[] args) {
		LinkedList[] blastresults = getBlastResults();
		LinkedList[] fourier = getFourierResults();
		LinkedList[] fouriernames = getFourierNames();
		LinkedList[] normalresults = GetNormalResults();
		LinkedList[] normalnames = getNormalNames();
		LinkedList[] blastresults2 = new LinkedList[10];
		for(int i = 0; i < blastresults.length;i++){
			blastresults2[i] = new LinkedList<String>();
			for(int j = 0; j < blastresults[i].size();j++){
				String item = (String) (blastresults[i].get(j));
				item = item.substring(0,item.length()-1);
				String items = item.split("[|]")[0];
				for(int p = 0; p < fouriernames[i].size();p++){
					if(items.equals(fouriernames[i].get(p))){
						blastresults2[i].add(blastresults[i].get(j));
					}
				}
				
			}
		}
		blastresults = blastresults2;
		int numberofqueries = 49*10;
		int totalnumberofrelevant = 0;
		float totalrecall = 0;
		int[] relevantonchanged = new int[10];
		for(int i = 0; i < 1;i++){
			for(int j = 0; j < blastresults[i].size();j++){
				String[] fasit = ((String)blastresults[i].get(j)).split("[|]");
				String[] query = ((String)fourier[i].get(j)).split("[|]");
				int numberofhits = query.length;
				int numberofrelevant = 0;
				for(int f = 0; f < fasit.length;f++){
					String r = fasit[f];
					if(((String)fourier[i].get(j)).contains(r)){
						numberofrelevant += 1;
					}
					
				}
				relevantonchanged[i] += numberofrelevant;
				totalnumberofrelevant += numberofrelevant;
				float recall = (float)((float)numberofrelevant/(float)numberofhits);
				totalrecall += recall;
			}
		}
		totalrecall = totalrecall/(float)numberofqueries;
		HashMap<String, Integer> lengths = GetSequenceLengths();
		
		int[] avghit = new int[10];
		int[] hitters = new int[normalresults.length*normalresults[0].size()];
		HashMap[] hitslength = new HashMap[10];
		int hitcount = 0;
		for(int i = 0; i < normalresults.length;i++){
			int hits = 0;
			int hito = 0;
			hitslength[i] = new HashMap<String, Integer>();
			for(int j = 0; j<normalresults[i].size();j++){
				String qsequence = (String)normalnames[i].get(j);
				int len = lengths.get(qsequence);
				String res = ((String)normalresults[i].get(j));
				//System.out.println(qsehttp://fukung.net/randomquence+" "+res);
				hitslength[i].put(qsequence, 0);
				if(res.contains(qsequence)){
					hits++;
					hitslength[i].put(qsequence, 1);
				}
				hitters[hitcount] = hits;
				hitcount ++;
				
			}
			
			avghit[i] = hits+1;
		}
		HashMap actualhitsperquery = new HashMap();
		for(int i = 0; i < 10; i++){
			HashMap tmp = hitslength[i];
			Set km = tmp.keySet();
			Iterator it = km.iterator();
			while(it.hasNext()){
				String key = (String) it.next();
				int old = 0;
				if(actualhitsperquery.containsKey(key)){
					old = ((Integer)actualhitsperquery.get(key)).intValue();
				}
				int curr = ((Integer)tmp.get(key)).intValue();
				int neww = old+curr;
				actualhitsperquery.put(key, neww);
			}
			
		}
		Set km = actualhitsperquery.keySet();
		Iterator it = km.iterator();
		char tab = '\t';
		while(it.hasNext()){
			String key = (String) it.next();
			int value = ((Integer)actualhitsperquery.get(key)).intValue();
			
			System.out.println(key+","+tab+lengths.get(key)+","+tab+value);
		}
		
		String tmp = "";
		//System.out.println(avghit.length);
		int[] ary = {0,5,10,15,20,25,30,35,40,45,};
		for(int i = 0; i < avghit.length;i++){
			//System.out.println(i*5+","+avghit[i]);
		}
		
		
	}
	
	public static LinkedList<String>[] GetNormalResults(){
		LinkedList[] retval = new LinkedList[10];
		String p = "/Users/alex/Documents/Skole/Masteroppgave/";
		String[] files = {"results_regular_changed.txt",};
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		String erroritem = "";
		String tab = '\t'+"";
		int retvalcounter =0;
		for(int i = 0; i < files.length;i++){
			try{
				retval[i] = new LinkedList<String>();
				fis = new FileInputStream(p+files[i]);
			    bis = new BufferedInputStream(fis);
			    dis = new DataInputStream(bis);
			    int state = 0;
			    String output = "";
			    int linecounter = 0;
			    String lol = "";
			    boolean jada = false;
				while (dis.available() != 0) {
					linecounter ++;
					boolean other = false;
					String line = dis.readLine();
					if(line.contains("<changed")){
						retval[retvalcounter] = new LinkedList<String>();
					}else if(line.contains("###")){
						
						if(lol.length() != 0){
							retval[retvalcounter].add(lol);
							lol = "";
						}
					}else if(line.contains("RESULT")){
						if(lol.length() != 0){
							
						}
					}else if(line.contains("</changed")){
						retval[retvalcounter].add(lol);
						lol = "";
						retvalcounter ++;
					}
					else{
						String item = line.substring(1,line.length());
						String[] items = item.split("[|]");
						lol+= items[2].substring(0,12)+"|";
					}
					
				}
				
			}catch(Exception e){
				e.printStackTrace();
			}
		
		}
		return retval;
	}
	
	public static LinkedList<String>[] getNormalNames(){
		LinkedList[] retval = new LinkedList[10];
		String p = "/Users/alex/Documents/Skole/Masteroppgave/";
		String[] files = {"resultsscaled_1000_.txt",};
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		String erroritem = "";
		String tab = '\t'+"";
		int retvalcounter =0;
		for(int i = 0; i < files.length;i++){
			try{
				retval[i] = new LinkedList<String>();
				fis = new FileInputStream(p+files[i]);
			    bis = new BufferedInputStream(fis);
			    dis = new DataInputStream(bis);
			    int state = 0;
			    String output = "";
			    int linecounter = 0;
			    String lol = "";
				while (dis.available() != 0) {
					linecounter ++;
					boolean other = false;
					String line = dis.readLine();
					if(line.contains("<changed")){
						retval[retvalcounter] = new LinkedList<String>();
					}else if(line.contains("###")){
						
					}else if(line.contains("RESULT")){
						
							retval[retvalcounter].add(line.substring(19,31));
						
					}else if(line.contains("</changed")){
						retvalcounter ++;
					}
					else{
						String item = line.substring(1,line.length());
						//String[] items = item.split("[|]");
						//lol+= items[2].substring(0,12)+"|";
					}
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		
		}
		return retval;
	}
	
	
	public static LinkedList<String>[] getFourierResults(){
		LinkedList[] retval = new LinkedList[10];
		String p = "/Users/alex/Documents/Skole/Masteroppgave/";
		String[] files = {"results_fourier_changed.txt",};
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		String erroritem = "";
		String tab = '\t'+"";
		int retvalcounter =0;
		for(int i = 0; i < files.length;i++){
			try{
				retval[i] = new LinkedList<String>();
				fis = new FileInputStream(p+files[i]);
			    bis = new BufferedInputStream(fis);
			    dis = new DataInputStream(bis);
			    int state = 0;
			    String output = "";
			    int linecounter = 0;
			    String lol = "";
			    boolean jada = false;
				while (dis.available() != 0) {
					linecounter ++;
					boolean other = false;
					String line = dis.readLine();
					if(line.contains("<changed")){
						retval[retvalcounter] = new LinkedList<String>();
					}else if(line.contains("###")){
						
						if(lol.length() != 0){
							retval[retvalcounter].add(lol);
							lol = "";
						}
					}else if(line.contains("RESULT")){
						if(lol.length() != 0){
							
						}
					}else if(line.contains("</changed")){
						retval[retvalcounter].add(lol);
						lol = "";
						retvalcounter ++;
					}
					else{
						String item = line.substring(1,line.length());
						String[] items = item.split("[|]");
						lol+= items[2].substring(0,12)+"|";
					}
					
				}
				
			}catch(Exception e){
				e.printStackTrace();
			}
		
		}
		return retval;
	}

	public static LinkedList<String>[] getFourierNames(){
		LinkedList[] retval = new LinkedList[10];
		String p = "/Users/alex/Documents/Skole/Masteroppgave/";
		String[] files = {"results_fourier_changed.txt",};
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		String erroritem = "";
		String tab = '\t'+"";
		int retvalcounter =0;
		for(int i = 0; i < files.length;i++){
			try{
				retval[i] = new LinkedList<String>();
				fis = new FileInputStream(p+files[i]);
			    bis = new BufferedInputStream(fis);
			    dis = new DataInputStream(bis);
			    int state = 0;
			    String output = "";
			    int linecounter = 0;
			    String lol = "";
				while (dis.available() != 0) {
					linecounter ++;
					boolean other = false;
					String line = dis.readLine();
					if(line.contains("<changed")){
						retval[retvalcounter] = new LinkedList<String>();
					}else if(line.contains("###")){
						
					}else if(line.contains("RESULT")){
						
							retval[retvalcounter].add(line.substring(19,31));
						
					}else if(line.contains("</changed")){
						retvalcounter ++;
					}
					else{
						String item = line.substring(1,line.length());
						//String[] items = item.split("[|]");
						//lol+= items[2].substring(0,12)+"|";
					}
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		
		}
		return retval;
	}
	
	public static LinkedList<String>[] getBlastResults(){
		
		String p = "/Users/alex/Desktop/BlastResults/";
		String[] files = {"changed0.tex","changed10.tex","changed15.tex","changed20.tex","changed25.tex","changed30.tex","changed35.tex","changed40.tex","changed45.tex","changed5.tex",};
		LinkedList[] retval = new LinkedList[files.length]; 
		FileInputStream fis = null;
		BufferedInputStream bis = null;
		DataInputStream dis = null;
		String erroritem = "";
		String tab = '\t'+"";
		for(int i = 0; i < files.length;i++){
			try{
				retval[i] = new LinkedList<String>();
				fis = new FileInputStream(p+files[i]);
			    bis = new BufferedInputStream(fis);
			    dis = new DataInputStream(bis);
			    int state = 0;
			    String output = "";
			    int linecounter = 0;
				while (dis.available() != 0) {
					linecounter ++;
					boolean other = false;
					String line = dis.readLine();
					if(line.contains("Rank")){
						state = 1;
					}else if(line.contains("}")){
						if(output.length() != 0){
							retval[i].add(output);
							//Debugger.Debug(output);
						}
						output = "";
						state = 0;
					}else if(state == 1){
						line = line.replace(tab,"");
						line = line.replace("\\", "");	
						line = line.replace("hline", "");
						line = line.replace(" ", "");
						try{
							output += line.split("&")[2]+"|";
						}catch(Exception e){
							Debugger.Debug("ERROR:"+line);
							Debugger.Debug("On File:"+files[i]+",line:"+linecounter);
							e.printStackTrace();
						}
					}
					
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		return retval;
			
	}

}
