package ag.lirebenchmark.blastsearch;

import java.util.LinkedList;

import org.concordia.cs.common.ncbi.qblast.PutCommand;
import org.concordia.cs.common.ncbi.qblast.QBlastRequest;
import org.concordia.cs.common.ncbi.qblast.Runner;

import ag.debug.Debugger;

public class BlastSearcher {
	LinkedList<String> output;
	LinkedList<String> numbers;
	String name;
	String id;
	Boolean running;
	public BlastSearcher(String name){
		this.name = name;
		output = new LinkedList<String>();
		numbers = new LinkedList<String>();
	}
	public void performQuery(String query, String id){
		running = true;
		PutCommand put_command = new PutCommand();
        put_command.setQuery(query);
        put_command.setDatabase("wgs");
        put_command.setExpectValue(300.0);
        put_command.setHitListSize(15);
        put_command.setGeneticCode(1);
        put_command.setDescriptions(50);
        put_command.setProgram("blastn");
        put_command.setIdentityPrecision(1);
        BlastGetter getter = new BlastGetter(this);//new BlastGetter("test");
        Runner runner = new Runner(put_command, getter);
        runner.start();
        System.out.println("Waiting for result");
        while(running){
        	try {
				Thread.currentThread().sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        	
        }
        this.id = id;
	}
	public void addItem(String item){
		running = false;
		output.add(item);
		numbers.add(id);
		Debugger.Debug("ITEM ADDED");
	}
}
