package ag.genomeencoder.image;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.util.LinkedList;

import ag.genomeencoder.encoder.GenomeEntity;
import ag.genomeencoder.encoder.GenomeSequence;

public class SimpleAlgorithm implements ImageProcessingAlgorithm {
	private GenomeSequence seq;
	public SimpleAlgorithm(GenomeSequence sequence){
		this.seq = sequence;
	}
	
	public BufferedImage Process(BufferedImage image) {
		LinkedList<GenomeEntity> list = seq.getList();
		for(int i = 0; i < list.size();i++){
			String part = list.get(i).decode();
			Color tmp = getColorFromString(part);
			int y = (int) Math.floor(i/image.getWidth());
			int x = (i-(y*image.getWidth()));
			image.setRGB(x, y, tmp.getRGB());
		}
		
		return image;
	}
	private Color getColorFromString(String input){
		int r = 0,g = 0,b = 0,a = 0,colorIncrement = 0;
		if(input.length() == 0){
			return new Color(0,0,0,0);
		}
		colorIncrement = Math.round(255/input.length());
		for(int i = 0; i < input.length();i++){
			char nuc = input.charAt(i);
			switch(nuc){
			case 'a':
				r += colorIncrement;
				break;
			case 'c':
				g += colorIncrement;
				break;
			case 't':
				b += colorIncrement;
				break;
			case 'g':
				a += colorIncrement;
				break;
			}
			
		}
		
		return new Color(r,g,b,a);
	}

}
