package org.concordia.cs.common.ncbi.qblast;


/**
 * @author: Farzad
 * @created: May 23, 2006
 */
public class Runner extends Thread
{
    public Runner(PutCommand put_command, GetCommand get_command)
    {
        this.putCommand = put_command;
        this.getCommand = get_command;
    }

    public synchronized void run()
    {
        try
        {
            long time = System.currentTimeMillis() + 1000;

            while (time>System.currentTimeMillis())
                yield();
            
            QBlastRequest.runCommand(putCommand);

            int wait_time = putCommand.getWaitingTime() * 1000;

            if (wait_time == 0)
                wait_time = 3000;

            do
            {
                time = System.currentTimeMillis() + wait_time;

                while (time>System.currentTimeMillis())
                    yield();

                wait_time = 5000;
                
                getCommand.setRequestID(putCommand.getRequestID());
                
                try
                {
                	QBlastRequest.runCommand(getCommand);
                }
                catch (Exception e)
                {
                	System.out.println("An exception happened during connecting to ncbi site. Trying again... Execption is: ");
                	e.printStackTrace();
                	System.out.println("Command is: " + getCommand );
                	continue;
                }
            }
            while (!getCommand.getStatus().contains(GetCommand.STATUS_READY)) ;
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    public GetCommand getGetCommand()
    {
        return getCommand;
    }

    public PutCommand getPutCommand()
    {
        return putCommand;
    }

    PutCommand putCommand;
    GetCommand getCommand;
}
